ISSUE-id - Bug #2445

SVN integration: Commit with new issue-id does not work

19 Jul 2018 08:38 - daniel wieselwind

Status: Under Verification
Priority: Major

Assignee: Andriy Lesyuk
Category:

Target version: 0.0.3

Redmine version:

Start date: 20 Jul 2018
Due date:

% Done: 50%
Estimated time: 0.00 hour

External issue:

Description

Committiong a revision with refers #1SSUE-1234 does not work. The revision is not linked to the issue.

Associated revisions

Revision 39 - 20 Jul 2018 11:25 - Andriy Lesyuk

Fix typo (#ISSUE-17)

Revision 40 - 29 Mar 2020 11:25 - Andriy Lesyuk

Fixed crash in changeset handling (#ISSUE-17)

History

#1 - 20 Jul 2018 11:30 - Andriy Lesyuk

- Tracker changed from Omission to Bug

- Status changed from New to Under Verification
- Assignee set to Andriy Lesyuk

- Priority changed from Normal to Major

- Target version set to 0.0.3

- Start date set to 20 Jul 2018

- % Done changed from 0 to 50

daniel, r39 can fix this issue. Please test (you'll need to update code from SVN/Git).

#2 - 21 Jul 2018 07:10 - daniel wieselwind
Hi,

| have tried several commit messages, and am able to break all commits with a (malformed) “refs 2802” here:

/var/www/redmine/plugins/redmine_issue_checklist/init.rb:24: warning: key :issue_checklist is duplicated and o

verwritten on line 24
rake aborted!

NoMethodError: undefined method "include?'

for 2802:Integer

/var/www/redmine/plugins/issue_id/lib/issue_changeset_patch.rb:38:in " find_referenced_issue_by_id_with_full_id

/var/www/redmine/app/models/changeset.
/var/www/redmine/app/models/changeset.
/var/www/redmine/app/models/changeset.
/var/www/redmine/app/models/changeset.
/var/www/redmine/app/models/changeset.

rb:
rb:
rb:
rb:
rb:

134:
133:
133:
129:
129:

in
in
in
in
in

“block (2 levels) in scan_comment_for_issue_ids'
“each'

"block in scan_comment_for_issue_ids'

“scan'

“scan_comment_for_issue_ids'

/var/www/redmine/plugins/issue_id/lib/issue_changeset_patch.rb:77:in 'scan_comment_for_issue_ids_with_full_ids

/var/www/redmine/plugins/redmine_code_review/lib/code_review_changeset_patch.rb:167:in " scan_comment_for_issue

_ids_with_code_review'

/var/www/redmine/app/models/changeset.rb:102:in "“scan_for_issues'
/usr/local/rvm/gems/ruby-2.4.1/gems/activesupport-4.2.8/1lib/active_support/callbacks.rb:432:in “block in make_

lambda'

/usr/local/rvm/gems/ruby-2.4.1/gems/activesupport—-4.2.8/1lib/active_support/callbacks.rb:228:in "block in halti
http://projects.andriylesyuk.com/users/dwieselwind
http://projects.andriylesyuk.com/projects/issue-id/repository/revisions/39

ng_and_conditional'
/usr/local/rvm/gems/ruby-2.
/usr/local/rvm/gems/ruby-2.
/usr/local/rvm/gems/ruby-2.
/usr/local/rvm/gems/ruby-2.
Al
/usr/local/rvm/gems/ruby-2.
llbacks'
/usr/local/rvm/gems/ruby-2.
/usr/local/rvm/gems/ruby-2.
/usr/local/rvm/gems/ruby-2.
te'
/usr/local/rvm/gems/ruby-2.
or_update'
/usr/local/rvm/gems/ruby-2.
/usr/local/rvm/gems/ruby-2.
s) in compile'
/usr/local/rvm/gems/ruby-2.
/usr/local/rvm/gems/ruby-2.

/usr/local/rvm/gems/ruby-2.
backs'
/usr/local/rvm/gems/ruby-2.
Al
/usr/local/rvm/gems/ruby-2.
/usr/local/rvm/gems/ruby-2.
/usr/local/rvm/gems/ruby-2.
e
/usr/local/rvm/gems/ruby-2.
1s) in save'
/usr/local/rvm/gems/ruby-2.

4

.1/gems/activesupport-4.
.1/gems/activesupport-4.
.1/gems/activesupport-4.
.1/gems/activesupport-4.

.8/1lib/active_support/callbacks.
.8/1lib/active_support/callbacks.
.8/1lib/active_support/callbacks.
.8/1lib/active_support/callbacks.
.1/gems/activesupport-4.2.8/1lib/active_support/callbacks.
8/1lib/active_record/callbacks.rb
8/lib/active_record/timestamp.rb
8/1ib/active_record/persistence.

.1/gems/activerecord-4.2.
.1/gems/activerecord-4.2.
.1/gems/activerecord-4.2.
.1/gems/activerecord-4.2.8/1lib/active_record/callbacks.rb
.1/gems/activesupport-4.2.8/1lib/active_support/callbacks.
.1/gems/activesupport-4.2.8/1lib/active_support/callbacks.
.1/gems/activesupport-4.
.1/gems/activesupport—-4.

.8/1lib/active_support/callbacks.
.8/1lib/active_support/callbacks.

.1/gems/activesupport-4.2.8/1lib/active_support/callbacks.

.1/gems/activerecord-4.2.8/lib/active_record/callbacks.rb
.8/1lib/active_record/persistence.
.8/1lib/active_record/validations.
.8/1lib/active_record/attribute_me

.1/gems/activerecord-4.
.1/gems/activerecord-4.
.1/gems/activerecord-4.

.1/gems/activerecord-4.2.8/lib/active_record/transactions

.1/gems/activerecord-4.2.8/1lib/active_record/transactions

_transaction_returning_status'

/usr/local/rvm/gems/ruby-2.4.1/gems/activerecord-4.

_statements.rb:211:in
/usr/local/rvm/gems/ruby-2.
/usr/local/rvm/gems/ruby-2.
ion_returning_status'
/usr/local/rvm/gems/ruby-2.
A}
/usr/local/rvm/gems/ruby-2.
ve_record_state!'
/usr/local/rvm/gems/ruby-2.
/usr/local/rvm/gems/ruby-2.
istence.rb:46:in "create'

/var/www/redmine/app/models/repository/subversion.rb:
/usr/local/rvm/gems/ruby—-2.4.1/gems/activerecord-4.2.
"block in transaction'

_statements.rb:213:in

/usr/local/rvm/gems/ruby-2.4.1/gems/activerecord-4.2.

ion.rb:184:in

_statements.rb:213:in

/usr/local/rvm/gems/ruby-2.4.1/gems/activerecord-4.2.
/usr/local/rvm/gems/ruby-2.4.1/gems/activerecord-4.2.
/var/www/redmine/app/models/repository/subversion.
/var/www/redmine/app/models/repository/subversion.
/var/www/redmine/app/models/repository/subversion.
/var/www/redmine/app/models/repository.rb:346:1in
/usr/local/rvm/gems/ruby—-2.4.1/gems/activerecord-4.2.8/1lib/active_record/relation/delegation.
/usr/local/rvm/gems/ruby-2.4.1/gems/activerecord-4.2.8/1lib/active_record/relation/delegation.

4
4

.8/1lib/active_record/connection_a

“transaction'

.1/gems/activerecord-4.
.1/gems/activerecord-4.

.1/gems/activerecord-4.

.1/gems/activerecord-4.

.1/gems/activerecord-4.2.8/lib/active_record/transactions.

.1/gems/protected_attributes-1.1.4/1ib/active_record/mass

72:in “block (2 levels) in fetch
8/1lib/active_record/connection_a

8/1lib/active_record/connection_a

"within_new_transaction'
/usr/local/rvm/gems/ruby-2.4.1/gems/activerecord-4.2.
“transaction'

8/lib/active_record/connection_a

8/lib/active_record/transactions
8/lib/active_record/transactions
71:in “block in fetch_changesets
70:in "reverse_each'

70:in " fetch_changesets'

(2 levels) in fetch_changeset

rb:
rb:
rb:
"block

/var/www/redmine/app/models/repository.rb:344:in “block in fetch_changesets'

/usr/local/rvm/gems/ruby—-2.4.1/gems/activerecord-4.2.8/1lib/active_record/relation/delegation.
/usr/local/rvm/gems/ruby-2.4.1/gems/activerecord-4.2.8/1lib/active_record/relation/delegation.

| have patched this with

if id.present? && id.to_s.include?(’-")

and bypassed this issue.

23 Aug 2025

.8/1lib/active_record/transactions.
.8/1lib/active_record/transactions.

.8/1lib/active_record/transactions.

.8/1lib/active_record/transactions.

rb:506:in "block in call'
rb:506:in "“each’
rb:506:in “call’

rb:92:in " _ _run_callbacks
rb:778:1in " _run_create_ca
:306:1in ' _create_record'
:57:in *_create_record'

rb:504:in "“create_or_upda

:302:in “block in create_
rb:117:in “call’
rb:555:in “block (2 level
rb:505:in “call’
rb:92:in “__run_callbacks
rb:778:1in "~ _run_save_call

:302:1in “create_or_update

rb:120:in "~ save'
rb:37:1in “save'
thods/dirty.rb:21:in 'sav

.rb:286:in “block (2 leve
.rb:351:in “block in with

dapters/abstract/database

rb:220:in “transaction'
rb:348:in “with_transact
rb:286:in “block in save
rb:301:in “rollback_acti
rpb:285:in " save'

_assignment_security/pers

_changesets'
dapters/abstract/database

dapters/abstract/transact

dapters/abstract/database

.rb:220:in "transaction'
.rb:277:1in “transaction'
A}
S A}
rb:46:in “each'
rb:46:1in “each'
rb:46:in “each'
rb:46:1in “each'
However, our programmers don’t always write uppercase, we need to change issue_changeset_patch.rb(17)!:

ISSUE_ID_RE = %r{[A-Za-z][a-zA-Z0-9]*-\d+}
